import os
import argparse

parser = argparse.ArgumentParser()
parser.add_argument('--dir_path', help='path to the directory containing repertoire files, for which a metadata file '
                                       'is to be generated in the same path supplied', required=True)
args = parser.parse_args()


def generate_metadata_file(dir_path):
    file_list = [fn for fn in os.listdir(dir_path) if fn.endswith(".tsv")]
    id_list = ["".join(["subject", str(i)]) for i in range(1, len(file_list) + 1)]
    print("basename of this directory is:---", os.path.basename(dir_path))
    print("supplied directory is:---", dir_path)
    file_path = os.path.join(dir_path, os.path.basename(dir_path) + "_metadata.csv")
    with open(file_path, "w+") as outfile:
        header = "filename" + "," + "subject_id" + "\n"
        outfile.write(header)
        for file, sub_id in zip(file_list, id_list):
            line = file + "," + sub_id + "\n"
            outfile.write(line)


def execute():
    generate_metadata_file(args.dir_path)


# if __name__ == "__main__":
#     os.chdir("/Users/kanduric/Documents/Projects/immuneML_test/")
#     generate_metadata_file("exp_random_repertoires/")
